// Sample Ikon Application
#include <ikon.h>          /* ikon.h should ALWAYS be first  */
#include <string.h>
#include <gui.h>
#define TOPY 50
#define S_IWUSR         00200

void freeicons();
void cleardir();
void AddFileList();
void dodirfunction(int data);
void closeinputwin(int data);
void renamefile();
void dopaste(int data);
int ourwinid;                   /* the id of our window */
int okaybut;
int upbut;
int upid;
int did;
int boxid;
BITMAP *winbmp;
//BITMAP *bgbmp;
char linkcaption[100];
char linkicon[100];
char linkfile[100];
char linkfolder[100];
char sel[256];
char curfile[256];
char temppath[256];
char curdir[256];
char openprog[256];     //for opening files with another program
char copyfilefull[256];
char copyfileshort[20];
int iconbox;	//id for our icon edit box when creating a shortcut
int erasewin;   //id for our erase file confirmation window
int starty;
int black;
int white;
int inputwin;   //id for the dir input window
int lastfileid;	//last file id clicked on
void AddFileList(void);
void dorefresh(int data);


typedef struct ffiles FFILES;
struct ffiles{
        int used;
        int icon;
        char fullname[60];
        char shortname[20];
	unsigned long filesize;
	unsigned char attrib;

        int hasicon;    /*1 if it has an icon or 0 if not */
};
FFILES file[501];        

void *var_router(DCM *dcm, int var)
{
   return(0);
}

void blankfunc(void)
{
        //nothing to do here
        RefreshWin(ourwinid);
};

void goup()
{
        starty=TOPY;
        strcat(curdir,"/..");
        cleardir();
        AddFileList();
        RefreshWin(ourwinid);
};

void closeconfirm(int data)
{
        CloseWin(erasewin);
	erasewin=0;
};

static void shutdown()
{
        CloseWin(ourwinid);
        ExitApp(pid);
};

void goapp()
{
        RunApp(sel);
};

void cleardir()
{
        int cnt;
        //make a white box for the icons
        cnt=0;
        rectfill(winbmp,3,45,645,495,white);
	//blit(bgbmp,winbmp,0,0,3,45,642,450);
        rect(winbmp,3,45,645,495,black);
        freeicons();
        RefreshWin(ourwinid);
};


void freeicons()
{
        int cnt;
        cnt=0;
        do{
                cnt++;
                if(file[cnt].used==1)
                {
                        if(file[cnt].hasicon==1)
                        {
                                FreeIcon(file[cnt].icon);
                        }
                        file[cnt].used=0;
                        file[cnt].hasicon=0;
                        memset(file[cnt].shortname,0,sizeof(file[cnt].shortname));
                        memset(file[cnt].fullname,0,sizeof(file[cnt].fullname));

                }
                if(cnt==500)
                        break;
        }while(1);

};

void leftclickdir(int id)
{
        strcat(curdir,"/");
        strcat(curdir,file[id].shortname);
        starty=TOPY;
        cleardir();
        AddFileList();
        RefreshWin(ourwinid);
};

void dodeltree(int option)
{
	if(option==1)
	{
		//clear dir off the root dir
		system(sel);
                rmdir(file[lastfileid].fullname);
	}
	else
	{
		system(sel);
	}
	closeconfirm(0);
        cleardir();
        AddFileList();
        RefreshWin(ourwinid);
}

void showerasedirwin(int option)
{
        erasewin=MakeWindow(200,200,200,60,"Delete Directory?",closeconfirm,0);
        MakeButton(erasewin,40,30,"Erase",dodeltree,option);
        MakeButton(erasewin,110,30,"Cancel",closeconfirm,0);
        ShowWin(erasewin);
};

void dodirrename(int data)
{
	char buff[200];
	memset(buff,0,sizeof(buff));
	closeinputwin(0);
	strcpy(buff,curdir);
	strcat(buff,"\\");
	strcat(buff,temppath);
	if(data==1)
	{
		//rename a directory
		rename(file[lastfileid].fullname,buff);
	}
	cleardir();
	AddFileList();
	RefreshWin(ourwinid);
}

void renamedir()
{
        inputwin=MakeWindow(300,200,200,80,"New Name?",closeinputwin,0);
        memset(temppath,0,sizeof(temppath));
        AddEditBox(inputwin,5,20,185,temppath,dodirrename,1);
        MakeButton(inputwin,55,50,"Okay",dodirrename,1);
        MakeButton(inputwin,107,50,"Cancel",closeinputwin,0);
        RefreshWin(inputwin);
}

void dodirmenu(int data)
{
	if(data==2)
	{
		//deltree the directory
                memset(sel,0,sizeof(sel));
		if(strlen(curdir)==3)
		{
			strcpy(sel,"deltree /Y ");
			strcat(sel,file[lastfileid].fullname);
			strcat(sel,"/");
			showerasedirwin(1);
		}
		else{
			strcpy(sel,"deltree /Y ");
	                strcat(sel,file[lastfileid].fullname);
			showerasedirwin(2);
		}
	}
	if(data==1)
	{
		//rename the directory
		renamedir();
	}
}

void dirclick(int id)
{
        int lastmb;
	if(erasewin!=0)
	{
		SetFocusOn(erasewin);
		RefreshWin(erasewin);
		return;
	}
        //id contains the file selection
	lastfileid=id;
        lastmb=GetLastMouseB();   //we want the second mouse button
        if(lastmb==1)
        {
                leftclickdir(id);
                return;
        }
        PopMenu("Rename,none,Delete,none",dodirmenu);
};

void doerase(int data)
{
                CloseWin(erasewin);
		erasewin=0;
                remove(curfile);
                cleardir();
                AddFileList();
		if(strstr(curfile,".LNK")!=0)
		{
			RefreshIcons();
			return;
		}
	        RefreshWin(ourwinid);
};

void showerasewin()
{
        erasewin=MakeWindow(200,200,200,60,"Erase File?",closeconfirm,0);
        MakeButton(erasewin,40,30,"Erase",doerase,0);
        MakeButton(erasewin,110,30,"Cancel",closeconfirm,0);
        ShowWin(erasewin);
};

void leftclickfile()
{
        char thisfile[256];
        memset(thisfile,0,sizeof(thisfile));
        strcpy(thisfile,curfile);
        strupr(thisfile);
        if(strstr(thisfile,".GIF")!=0 || strstr(thisfile,".JPG")!=0 || strstr(thisfile,".BMP")!=0 || strstr(thisfile,".PCX")!=0)
        {
                memset(sel,0,sizeof(sel));
                strcpy(sel,"programs/iview.app ");
                strcat(sel,curfile);
                RunApp(sel);
                return;
        }
        if(strstr(thisfile,".APP")!=0)
        {
                RunApp(curfile);
                return;
        }
        if(strstr(thisfile,".TXT")!=0 || strstr(thisfile,".DOC")!=0 || strstr(thisfile,".C")!=0)
        {
                if(strstr(thisfile,".COM")!=0)
                        return;
                memset(sel,0,sizeof(sel));
                strcpy(sel,"programs/edit.app ");
                strcat(sel,curfile);
                RunApp(sel);
                return;
        }
};

void openwith()
{
        memset(sel,0,sizeof(sel));
        strcpy(sel,openprog);
        strcat(sel," ");
        strcat(sel,curfile);
        RunApp(sel);

};

void fileproperties(int id)
{
	//id should contain the id of the last file clicked
	BITMAP *bmp;
	char attribs[6];
	memset(attribs,0,6);
	strcpy(attribs,"+");
	/*if(file[id].attrib&1==1)
		strcat(attribs,"R");
	if(file[id].attrib&2==2)
		strcat(attribs,"H");
	if(file[id].attrib&4==4)
		strcat(attribs,"S");*/
	if(file[id].attrib&32==32)
		strcat(attribs,"A");
        erasewin=MakeWindow(200,200,320,200,"File Properties",closeconfirm,0);
	bmp=GetWinBMP(erasewin);
	rectfill(bmp,2,20,318,61,makecol(255,255,255));
	rect(bmp,2,20,318,61,0);
	textprintf(bmp,SystemFont(),4,25,0,"  FILE            SIZE    ATTRIB");
	textprintf(bmp,SystemFont(),4,27,0,"_________________________________");
	textprintf(bmp,SystemFont(),4,45,0,"%12s %10u  %s",
	file[id].shortname,file[id].filesize,attribs);
        ShowWin(erasewin);
}

void addshortcut(int option)
{
	//add the shortcut from makeshortcut window
	FILE *f;
	char *fbuff;
	char lbuff[100];
	char imktemp[8];
	int temp;
	int cnt;
	struct time t;
	closeconfirm(0);
	if(linkfile[0]==0 || linkicon[0]==0 || linkcaption[0]==0)
		return;
	if(option==2)
	{
		memset(linkfolder,0,sizeof(linkfolder));
		strcpy(linkfolder,"desktop\\");
	}
	else{
		strcat(linkfolder,"\\");
	}
	cnt=0;
	do{
		memset(lbuff,0,sizeof(lbuff));
		strcpy(lbuff,linkfolder);
		memset(imktemp,0,8);
		itoa(cnt,imktemp,10);
		strcat(lbuff,imktemp);
		strcat(lbuff,".lnk");
		f=fopen(lbuff,"r");
		if(f==0)
		{
			break;
		}
		else
		{
			fclose(f);
		}
		cnt++;
	}while(1);
	f=fopen(lbuff,"wt");
	fputs(linkcaption,f);
	fputs("\n",f);
	fputs(linkfile,f);
	fputs("\n",f);
	fputs(linkicon,f);
	fputs("\n",f);
	fclose(f);

	RefreshIcons();
	SetFocusOn(ourwinid);
}

void refreshshortcuts()
{
	RefreshEditBox(iconbox);
	RefreshWin(erasewin);
}

void getshortcuticon(int data)
{
	memset(linkicon,0,sizeof(linkfolder));
	FileSelector("*.*",refreshshortcuts,&linkicon);
}

void chosefolder()
{
	addshortcut(0);
}

void addshortcut2(int data)
{
	memset(linkfolder,0,sizeof(linkfolder));
	FileSelector("*.*",chosefolder,&linkfolder);
}

void makeshortcut(int id)
{
	int a,b;
        erasewin=MakeWindow(200,200,400,300,"Create Shortcut",closeconfirm,0);
	memset(linkicon,0,sizeof(linkicon));
	memset(linkfile,0,sizeof(linkfile));
	memset(linkfolder,0,sizeof(linkfolder));
	memset(linkcaption,0,sizeof(linkcaption));
	MakeLabelButton(erasewin,SystemFont(),3,20,0,"Title",blankfunc,0);
	a=AddEditBox(erasewin,3,35,390,linkcaption,0,0);
	MakeLabelButton(erasewin,SystemFont(),3,52,0,"File Shortcut",blankfunc,0);
	strcpy(linkfile,curdir);
	strcat(linkfile,"\\");
	strcat(linkfile,file[id].shortname);
	b=AddEditBox(erasewin,3,67,390,linkfile,0,0);
	MakeLabelButton(erasewin,SystemFont(),3,87,0,"Icon",blankfunc,0);
	strcpy(linkicon,"icons\\funknown.bmp");
	iconbox=AddEditBox(erasewin,3,102,360,linkicon,0,0);
	MakeIcon(erasewin,368,99,"icons\\folder.bmp"," ",getshortcuticon,0);
	MakeButton(erasewin,3,122,"Add To Desktop",addshortcut,2);
	MakeButton(erasewin,3,143,"Place In A Folder",addshortcut2,0);
	RefreshEditBox(a);
	RefreshEditBox(b);
	RefreshEditBox(iconbox);
        RefreshWin(erasewin);
}

void domenu(int data)
{
        //data values: 1 is run,2 is edit,3 is view img,4 is erase
        //5 is rename, 6 is copy
        //filename is in curfile
        if(data==1)
        {
                RunApp(curfile);
        }
        if(data==2)
        {
                memset(sel,0,sizeof(sel));
                strcpy(sel,"programs/edit.app ");
                strcat(sel,curfile);
                RunApp(sel);
        }
        if(data==3)
        {
                //open a file with a user selected program
                memset(openprog,0,sizeof(openprog));
                FileSelector("*.*",openwith,&openprog);
                return;
        }
        if(data==4)
        {
                //erase file
                showerasewin();
        }
        if(data==5)
        {
                //rename a file
                renamefile();
        }
        if(data==6)
        {
                //copy a file
                //handled when user first clicks icon if the file
                //so no need to do anything here
		copyfile(copyfilefull,"temp\\copy.tmp");
		PutClipboard(copyfilefull,strlen(copyfilefull));
        }
	if(data==7)
	{
		//file properties
		fileproperties(lastfileid);
	}
	if(data==8)
	{
		//create a shortcut to a file
		makeshortcut(lastfileid);
	}
};

void fileclick(int id)
{
        int lastmb;
        //id contains the file selection
	if(erasewin!=0)
	{
		SetFocusOn(erasewin);
		RefreshWin(erasewin);
		return;
	}
        memset(curfile,0,sizeof(curfile));
        strcpy(curfile,file[id].fullname);
        memset(copyfilefull,0,sizeof(copyfilefull));
        memset(copyfileshort,0,sizeof(copyfileshort));
        strcpy(copyfilefull,file[id].fullname);
        strcpy(copyfileshort,file[id].shortname);
	lastfileid=id;
        lastmb=GetLastMouseB();   //we want the second mouse button
        if(lastmb==1)
        {
                leftclickfile();
                return;
        }
        PopMenu("Run,none,Edit,none,Open With,none,Erase,none,Rename,none,Copy,none,Properties,none,Create Shortcut,none",domenu);
};


int checkiffile(char *fname)
{
        int cnt;
        int tmp;
        char *test;
        cnt=0;
        do{
                cnt++;
                tmp=strcmp(fname,file[cnt].shortname);
                if(tmp==0)
                        return 1;
                if(cnt==500)
                        return 0;
        }while(1);
};

void AddFileList()
{
        struct ffblk f;
        char bmpfile[60];
        int done;
        int temp;
        int cnt;
        int x,y;
        cleardir();
        memset(sel,0,sizeof(sel));
        fixpath(curdir,sel);
        strcpy(curdir,sel);
        memset(sel,0,sizeof(sel));
        strcpy(temppath,curdir);
        fixpath(temppath,sel);
        strcat(sel,"/*.*");
        RefreshEditBox(boxid);
        done=findfirst(sel,&f,FA_DIREC);
        if(done!=0)
                return;
        cnt=0;
        x=60;
        y=starty;
        while(!done)
        {
                cnt++;
                file[cnt].used=1;
                strcpy(file[cnt].fullname,curdir);
                strcat(file[cnt].fullname,"/");
                strcat(file[cnt].fullname,f.ff_name);
                strcpy(file[cnt].shortname,strupr(f.ff_name));
		file[cnt].filesize=f.ff_fsize;
		file[cnt].attrib=f.ff_attrib;
                strcpy(bmpfile,"icons\\funknown.bmp");
                if(strstr(file[cnt].shortname,".C")!=0)
                        strcpy(bmpfile,"icons\\paper.bmp");
                if(strstr(file[cnt].shortname,".H")!=0)
                        strcpy(bmpfile,"icons\\paper.bmp");
                if(strstr(file[cnt].shortname,".APP")!=0)
                        strcpy(bmpfile,"icons\\fapp.bmp");
                if(strstr(file[cnt].shortname,".DOC")!=0)
                        strcpy(bmpfile,"icons\\paper.bmp");
                if(strstr(file[cnt].shortname,".TXT")!=0)
                        strcpy(bmpfile,"icons\\paper.bmp");
                if(strstr(file[cnt].shortname,".COM")!=0)
                        strcpy(bmpfile,"icons\\fdos.bmp");
                if(strstr(file[cnt].shortname,".BAT")!=0)
                        strcpy(bmpfile,"icons\\fdos.bmp");
                if(strstr(file[cnt].shortname,".EXE")!=0)
                        strcpy(bmpfile,"icons\\fdos.bmp");
                if(strstr(file[cnt].shortname,".JPG")!=0)
                        strcpy(bmpfile,"icons\\fgf.bmp");
                if(strstr(file[cnt].shortname,".PCX")!=0)
                        strcpy(bmpfile,"icons\\fgf.bmp");
                if(strstr(file[cnt].shortname,".BMP")!=0)
                        strcpy(bmpfile,"icons\\image.bmp");
                if(strstr(file[cnt].shortname,".GIF")!=0)
                        strcpy(bmpfile,"icons\\fgf.bmp");
                if((y>40) && (y<450))
                {
			temp=f.ff_attrib&0x10;
			if(temp==0x10)
			{
	                        file[cnt].icon=MakeIcon(ourwinid,x,y,"icons\\ffolder.bmp",file[cnt].shortname,dirclick,cnt);
			}
			else
			{
	                        file[cnt].icon=MakeIcon(ourwinid,x,y,bmpfile,file[cnt].shortname,fileclick,cnt);
			}
                        file[cnt].hasicon=1;       /*type 2 is a file*/
                }
                if(cnt==500)
                        break;
                x=x+115;
                if(x>521)
                {
                        y=y+55;
                        x=60;
                };
                if(y>450)
                        break;
                done=findnext(&f);
        }
	return;
        //now we add the directory entries
        done=findfirst(sel,&f,FA_DIREC);
        if(done!=0)
                return;
        //cnt=0;
        while(!done)
        {
                //temp=checkiffile(strupr(f.ff_name));
		temp=f.ff_attrib&0x10;
                if(temp==0x10)
                {
                cnt++;
                file[cnt].used=1;
                strcpy(file[cnt].fullname,curdir);
                strcat(file[cnt].fullname,"/");
                strcat(file[cnt].fullname,f.ff_name);
                strcpy(file[cnt].shortname,strupr(f.ff_name));
		file[cnt].attrib=f.ff_attrib;
                if((y>40) && (y<450))
                {
                        file[cnt].icon=MakeIcon(ourwinid,x,y,"icons\\ffolder.bmp",file[cnt].shortname,dirclick,cnt);
                        file[cnt].hasicon=1;       /*type 1 is a dir*/
                }
                if(cnt==500)
                        break;
                x=x+115;
                if(x>521)
                {
                        y=y+55;
                        x=60;
                }
                if(y>450)
                        break;
                }
                done=findnext(&f);
        }
};

void pageup(int data)
{
	if(erasewin!=0)
	{
		SetFocusOn(erasewin);
		RefreshWin(erasewin);
		return;
	}
        starty=starty+55;
        cleardir();
        AddFileList();
        RefreshWin(ourwinid);
};

void pagedown(int data)
{
	if(erasewin!=0)
	{
		SetFocusOn(erasewin);
		RefreshWin(erasewin);
		return;
	}
        starty=starty-55;
        cleardir();
        AddFileList();
        RefreshWin(ourwinid);
};

void changedrive(int drive)
{
	if(erasewin!=0)
	{
		SetFocusOn(erasewin);
		RefreshWin(erasewin);
		return;
	}
        memset(curdir,0,sizeof(curdir));
        if(drive=='a')
        {
                strcpy(curdir,"A:/");
        }
        if(drive=='f')
        {
                strcpy(curdir,"F:/");
        }
        if(drive=='c')
        {
                strcpy(curdir,"C:/");
        }
        if(drive=='d')
        {
                strcpy(curdir,"D:/");
        }
        if(drive=='e')
        {
                strcpy(curdir,"E:/");
        }
        cleardir();
        AddFileList();
        RefreshWin(ourwinid);
};

void dodirfunction(int data)
{
        CloseWin(inputwin);
        if(data==1)
        {
                //makedir
                memset(sel,0,sizeof(sel));
                strcpy(sel,curdir);
                strcat(sel,"/");
                strcat(sel,temppath);
                mkdir(sel,S_IWUSR);
                cleardir();
                AddFileList();
                RefreshWin(ourwinid);
        }
        if(data==2)
        {
                //remove dir
                memset(sel,0,sizeof(sel));
                strcpy(sel,curdir);
                strcat(sel,"/");
                strcat(sel,temppath);
                rmdir(sel);
                cleardir();
                AddFileList();
                RefreshWin(ourwinid);
        }
        if(data==3)
        {
                //rename a file
                memset(sel,0,sizeof(sel));
                strcpy(sel,curdir);
                strcat(sel,"/");
                strcat(sel,temppath);
                rename(copyfilefull,sel);
                cleardir();
                AddFileList();
                RefreshWin(ourwinid);
        }
};

void closeinputwin(int data)
{
        CloseWin(inputwin);
};

void renamefile()
{
        inputwin=MakeWindow(300,200,200,80,"New Filename..",closeinputwin,0);
        memset(temppath,0,sizeof(temppath));
        AddEditBox(inputwin,5,22,185,temppath,dodirfunction,3);
        MakeButton(inputwin,55,50,"Okay",dodirfunction,3);
        MakeButton(inputwin,107,50,"Cancel",closeinputwin,0);
        RefreshWin(inputwin);
};

void newdir(int data)
{
        inputwin=MakeWindow(300,200,200,80,"New Folder Name?",closeinputwin,0);
        memset(temppath,0,sizeof(temppath));
        AddEditBox(inputwin,5,22,185,temppath,dodirfunction,1);
        MakeButton(inputwin,60,50,"Okay",dodirfunction,1);
        MakeButton(inputwin,112,50,"Cancel",closeinputwin,0);
        RefreshWin(inputwin);
};

void erasedir(int data)
{
        inputwin=MakeWindow(300,200,200,80,"Remove Folder",closeinputwin,0);
        memset(temppath,0,sizeof(temppath));
        AddEditBox(inputwin,5,22,185,temppath,dodirfunction,2);
        MakeButton(inputwin,60,50,"Okay",dodirfunction,2);
        MakeButton(inputwin,112,50,"Cancel",closeinputwin,0);
        RefreshWin(inputwin);
};

void dopaste(int data)
{
                //paste a file
		char errormsg[200];
		FILE *f1;
		char *cb;
                int cnt;
		cb=GetClipboard();
                memset(temppath,0,sizeof(temppath));
        	//fixpath(cb,temppath);
		strcpy(temppath,cb);
		cnt=strlen(temppath);
		do{
			cnt--;
			if(temppath[cnt]=='/' || temppath[cnt]=='\\')
			{
				memset(temppath,0,sizeof(temppath));
				strcpy(temppath,curdir);
				strcat(temppath,cb+cnt);
				break;
			}
			if(cnt==0)
				return;
		}while(1);
		memset(copyfilefull,0,sizeof(copyfilefull));
		strcpy(copyfilefull,"temp\\copy.tmp");
                copyfile(copyfilefull,temppath);
                cleardir();
                AddFileList();
                RefreshWin(ourwinid);
};

void dorefresh(int data)
{
	if(erasewin!=0)
	{
		SetFocusOn(erasewin);
		RefreshWin(erasewin);
		return;
	}
        cleardir();
        AddFileList();
        RefreshWin(ourwinid);
};

static void appmain()
{
  //*********[ Your main program routine ]****************
  InitGUI();
        char *tmp;
        tmp=GetPath(pid);
        strcpy(curdir,tmp);
        black=makecol(0,0,0);
        white=makecol(0xff,0xff,0xff);
	//bgbmp=load_bitmap("system\\winbg.jpg",0);
        starty=50;
	erasewin=0;
  ourwinid=MakeWindow(10,10,670,500,"FManager - 1.1",shutdown,0);
        boxid=AddEditBox(ourwinid,310,23,320,&curdir,dorefresh,0);
        MakeButton(ourwinid,633,23,"GO",dorefresh,0);
        upid=MakeButton(ourwinid,651,45,"-",pageup,0);
        did=MakeButton(ourwinid,651,480,"+",pagedown,0);
        MakeIcon(ourwinid,5,21,"icons/fupdir.bmp","",goup,0);
        MakeIcon(ourwinid,30,21,"icons/fmkdir.bmp","",newdir,0);
        MakeIcon(ourwinid,60,21,"icons/frmdir.bmp","",erasedir,0);
        MakeIcon(ourwinid,90,21,"icons/fref.bmp","",dorefresh,0);
        MakeButton(ourwinid,119,23,"Paste",dopaste,0);
        MakeButton(ourwinid,147+(1*26),23,"A:",changedrive,'a');
        MakeButton(ourwinid,147+(2*26),23,"C:",changedrive,'c');       
        MakeButton(ourwinid,147+(3*26),23,"D:",changedrive,'d');
        MakeButton(ourwinid,147+(4*26),23,"E:",changedrive,'e');
        MakeButton(ourwinid,147+(5*26),23,"F:",changedrive,'f');
        winbmp=GetWinBMP(ourwinid);
        cleardir();
        AddFileList();
    ShowWin(ourwinid);
        RefreshWin(ourwinid);
};



